unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls,
  VCLTee.TeEngine, VCLTee.TeeProcs, VCLTee.Chart, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Chart1: TChart;
    Memo1: TMemo;
    procedure Chart1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    PTarray : array of TPoint;
    Drawing : boolean;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Chart1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (ssCtrl in Shift) then
     begin
       // Check if we are starting to draw a new polygon
       if Length(PTarray) <= 0  then
         begin
           // Initialize the array to hold the polygon vertex list.
           // Allocate an extra element to hold the curent mouse position
           // and use it for the last/next vertex.
           SetLength(PTarray, 2);
           PTarray[0].X := X;
           PTarray[0].Y := Y;
           Drawing := True;
         end

       else if Length(PTarray) > 1 then
         begin
           // Clear the old line we were stretching to the last vertex
           Chart1.Canvas.Pen.Color := clBlack;
           Chart1.Canvas.Brush.Style := bsSolid;
           Chart1.Canvas.Pen.Mode := pmXor;
           Chart1.Canvas.Pen.Width := 1;
           Chart1.Canvas.Polyline(PTarray);

           // Increase the array to hold the new vertex.
           SetLength(PTarray, Length(PTarray)+1);
         end;

       // Save the new vertex
       PTarray[High(PTarray)].X := X;
       PTarray[High(PTarray)].Y := Y;

       // Draw a line from the previous vertex to this new one
       Chart1.Canvas.Pen.Color := clBlack;
       Chart1.Canvas.Brush.Style := bsSolid;
       Chart1.Canvas.Pen.Mode := pmXor;
       Chart1.Canvas.Pen.Width := 1;
       Chart1.Canvas.Polyline(PTarray);
     end
   else
     begin
       // Close the polygon;
       Drawing := False;
       SetLength(PTarray, Length(PTarray)+1);
       PTarray[High(PTarray)] := PTarray[0];
       Chart1.Canvas.Polyline(PTarray);
       SetLength(PTarray, 0);
     end;
end;


procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  // Check if we are drawing the polygon
  if Drawing then
    begin
      Chart1.Canvas.Pen.Color := clBlack;
      Chart1.Canvas.Brush.Style := bsSolid;
      Chart1.Canvas.Pen.Mode := pmXor;

      // Remove the old line
      Chart1.Canvas.Pen.Width := 1;
      Chart1.Canvas.Polyline(PTarray);

      // Save new point
      PTarray[High(PTarray)].X := X;
      PTarray[High(PTarray)].Y := Y;

      // Draw the new line
      Chart1.Canvas.Pen.Width := 1;
      Chart1.Canvas.Polyline(PTarray);
    end
end;

end.
